export default (({
  cssVarsHash: _cssVarsHash = {}
} = {}) => ({
  postcssPlugin: 'postcss-replace-css-vars',

  Declaration(decl) {
    if (decl.value && typeof decl.value === 'string') {
      decl.value = decl.value.replace(/--\S*/g, match => {
        if (_cssVarsHash[match]) {
          return _cssVarsHash[match];
        }

        return match;
      });
    }
  }

}));