import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import hoistNonReactStatics from 'hoist-non-react-statics';
import React, { useContext } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
export var DesignTokenContext = /*#__PURE__*/React.createContext({});
export var useDesignTokens = function useDesignTokens() {
  return useContext(DesignTokenContext);
};
export default (function () {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    name: '@modern-js/plugin-design-token',
    setup: function setup() {
      return {
        hoc: function hoc(_ref, next) {
          var App = _ref.App;

          var DesignTokenAppWrapper = function DesignTokenAppWrapper(props) {
            var _options$token = options.token,
                token = _options$token === void 0 ? {} : _options$token,
                _options$useStyledCom = options.useStyledComponentsThemeProvider,
                useStyledComponentsThemeProvider = _options$useStyledCom === void 0 ? false : _options$useStyledCom,
                _options$useDesignTok = options.useDesignTokenContext,
                useDesignTokenContext = _options$useDesignTok === void 0 ? false : _options$useDesignTok;

            if (useStyledComponentsThemeProvider && useDesignTokenContext) {
              var _require = require('@modern-js/runtime-core/styled'),
                  ThemeProvider = _require.ThemeProvider;

              return /*#__PURE__*/_jsx(ThemeProvider, {
                theme: token,
                children: /*#__PURE__*/_jsx(DesignTokenContext.Provider, {
                  value: token,
                  children: /*#__PURE__*/_jsx(App, _objectSpread({}, props))
                })
              });
            } else if (useStyledComponentsThemeProvider) {
              var _require2 = require('@modern-js/runtime-core/styled'),
                  _ThemeProvider = _require2.ThemeProvider;

              return /*#__PURE__*/_jsx(_ThemeProvider, {
                theme: token,
                children: /*#__PURE__*/_jsx(App, _objectSpread({}, props))
              });
            } else if (useDesignTokenContext) {
              return /*#__PURE__*/_jsx(DesignTokenContext.Provider, {
                value: token,
                children: /*#__PURE__*/_jsx(App, _objectSpread({}, props))
              });
            } else {
              return /*#__PURE__*/_jsx(App, _objectSpread({}, props));
            }
          };

          return next({
            App: hoistNonReactStatics(DesignTokenAppWrapper, App)
          });
        }
      };
    }
  };
});